Apple Preview libFontParser SpecialEncoding Remote Code Execution Vulnerability

2010-04-14T00:00:00
ID ZDI-10-076
Type zdi
Reporter Charlie Miller
Modified 2010-06-22T00:00:00

Description

This vulnerability allows remote attackers to execute arbitrary code on vulnerable installations of Apple Preview. User interaction is required in that a target must open a malicious file or visit a malicious page. The specific flaw exists within the routine TType1ParsingContext::SpecialEncoding() defined in libFontParser.dylib. While parsing glyphs from a PDF document, a malformed offset greater than 0x400 can result in a heap corruption which can be leveraged by an attacker to execute arbitrary code under the context of the current user.